Bug 229876 - iOS 15 Beta 8 VisualViewport.height does not account for address bar above virtual keyboard
Summary: iOS 15 Beta 8 VisualViewport.height does not account for address bar above vi...
Status: NEW
Alias: None
Product: WebKit
Classification: Unclassified
Component: Layout and Rendering (show other bugs)
Version: WebKit Nightly Build
Hardware: Unspecified Unspecified
: P2 Normal
Assignee: Nobody
URL:
Keywords: InRadar
Depends on:
Blocks:
 
Reported: 2021-09-03 09:43 PDT by Matan Hershberg
Modified: 2021-11-18 18:02 PST (History)
21 users (show)

See Also:


Attachments
Bottom text is covered by virtual keyboard' address bar (68.60 KB, image/png)
2021-09-03 09:43 PDT, Matan Hershberg
no flags Details
iOS 15 Beta 1 - Issue does NOT exist (106.99 KB, image/png)
2021-09-07 10:50 PDT, Matan Hershberg
no flags Details
Final iOS15 - extended tab bar also affected (588.73 KB, image/png)
2021-09-22 03:41 PDT, Kevin
no flags Details
iOS 15.1 beta nearly fixed it (514.69 KB, image/png)
2021-10-08 10:01 PDT, Kevin
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Matan Hershberg 2021-09-03 09:43:33 PDT
Created attachment 437279 [details]
Bottom text is covered by virtual keyboard' address bar

iOS 15 Beta 8

VisualViewport.height returns a pixel size that does not account for the address bar above the Virtual Keyboard.

This causes elements that are aligned to the bottom of the page, based on VisualViewport.height, to be hidden by the address bar above the Virtual Keyboard.


I created a test page at https://matan-hershberg-nuance.github.io/ios15-beta-visualviewport-bug/

The test page has an input box, and a paragraph tag that aligns to the bottom of viewport based on VisualViewport.height values.

When clicking the input box and the Virtual Keyboard goes up, the address bar covers the "Bottom" text.

I believe this was not reproducible in earlier versions of the Beta.
Comment 1 Radar WebKit Bug Importer 2021-09-05 14:42:35 PDT
<rdar://problem/82777262>
Comment 2 Penar Musaraj 2021-09-07 06:32:19 PDT
I have run into the same issue in Betas 6 and 7 too. (See also https://pmusaraj.github.io/ios15-bottom-bar2.html for a test page.)
Comment 3 Matan Hershberg 2021-09-07 10:50:43 PDT
Created attachment 437532 [details]
iOS 15 Beta 1 - Issue does NOT exist

In iOS 15 Beta 1 the VisualViewport.height is working correctly, and accounts for the address bar that's attached to the top of the virtual keyboard.
Comment 4 Simon Fraser (smfr) 2021-09-07 10:52:00 PDT
This is a known issue, but exists in Apple internal code, not WebKit.
Comment 5 christian 2021-09-07 10:57:14 PDT
Please link the "Apple internal code" issue.
Comment 6 Simon Fraser (smfr) 2021-09-07 10:59:02 PDT
<rdar://82206406>
Comment 7 Matan Hershberg 2021-09-07 11:05:29 PDT
Thanks Simon,

Is that rdar link something that's publicly available?
Comment 8 Simon Fraser (smfr) 2021-09-07 11:08:37 PDT
It is not.
Comment 9 christian 2021-09-07 11:22:31 PDT
(In reply to Simon Fraser (smfr) from comment #8)
> It is not.

I see it is not in open radar.
http://openradar.appspot.com/search?query=82206406

Can you / are you allowed to summarize the issue ?
(just giving a private id does not help).
Comment 10 Kevin 2021-09-22 03:41:51 PDT
Created attachment 438938 [details]
Final iOS15 - extended tab bar also affected
Comment 11 Drew Harris 2021-09-23 13:51:39 PDT
This issue still exists in the public release of iOS 15 - we're "accounting" for it by adding extra margin when a text field is focused, but that obviously makes the experience much worse for someone on iOS 15 who has moved the address bar back up to the top.
Comment 12 Tom 2021-10-08 03:18:14 PDT
Is there any update on this issue? Being unable to see the internal safari tracker means that we have no visibility on how this has been prioritised.
Comment 13 Kevin 2021-10-08 09:59:26 PDT
I got the new iOS 15.1 beta and surprise! It’s fixed.
Comment 14 Kevin 2021-10-08 10:01:14 PDT
Created attachment 440634 [details]
iOS 15.1 beta nearly fixed it
Comment 15 Yiannis St. 2021-11-10 06:02:40 PST
on IOS 15.1 - Issue do not exist also